> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gomaestro.org/llms.txt
> Use this file to discover all available pages before exploring further.

> Retrieves all UTXOs associated with a Bitcoin address or script pubkey. Ideal for wallet views, dust filtering, or balance calculations. Can be tailored to exclude certain categories of UTXOs such as those used in metaprotocols.

# UTxOs by Address



## OpenAPI

````yaml bitcoin/blockchain-indexer-api/openapi.json get /addresses/{address}/utxos
openapi: 3.0.3
info:
  title: Bitcoin - Blockchain Indexer API
  description: >-
    This API provides core indexer endpoints with support for Bitcoin
    metaprotocols by delivering real-time, rollback-protected access to
    Bitcoin's UTXO data, enabling developers to build responsive and reliable
    blockchain applications without managing complex infrastructure.


    #### Key Features:

    - **Real-Time Data with Rollback Protection:** Ensures data accuracy by
    handling chain reorganizations gracefully, providing live data without
    sacrificing integrity.

    - **Comprehensive UTXO Indexing:** Specialized pipelines extract, match, and
    process on-chain information, including handling rollbacks, to provide
    accurate and up-to-date data.


    #### Key Benefits for Developers:

    By abstracting the complexities of blockchain data retrieval and processing,
    Maestro's Bitcoin Indexer API empowers developers to focus on building
    innovative applications with confidence in fast and reliable access to
    historical chain data.
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.txt
  version: v0.2.0
servers:
  - url: https://xbt-mainnet.gomaestro-api.org/v0
    description: Bitcoin Mainnet
  - url: https://xbt-testnet.gomaestro-api.org/v0
    description: Bitcoin Testnet
security:
  - api-key: []
paths:
  /addresses/{address}/utxos:
    get:
      tags:
        - Addresses
      summary: UTxOs by Address
      description: >-
        Retrieves all UTXOs associated with a Bitcoin address or script pubkey.
        Ideal for wallet views, dust filtering, or balance calculations. Can be
        tailored to exclude certain categories of UTXOs such as those used in
        metaprotocols.
      operationId: utxos_by_address
      parameters:
        - name: address
          in: path
          description: Bitcoin address or hex encoded script pubkey
          required: true
          schema:
            type: string
          example: bc1phyrmjs2jm5c98tldke2ykp0h66lsx3wy0ey8ug2fjj5mxsn8ftqsa24un8
        - name: filter_dust
          in: query
          description: Ignore UTxOs containing less than 100000 sats
          required: false
          schema:
            type: boolean
            nullable: true
        - name: filter_dust_threshold
          in: query
          description: Ignore UTxOs containing less than specified satoshis
          required: false
          schema:
            type: integer
            format: int64
            nullable: true
            minimum: 0
        - name: exclude_metaprotocols
          in: query
          description: >-
            Exclude UTxOs involved in metaprotocols (currently only runes and
            inscriptions will be discovered, more metaprotocols may be supported
            in future)
          required: false
          schema:
            type: boolean
            nullable: true
        - name: ignore_used_brc20
          in: query
          description: >-
            When used with exclude_metaprotocols=true, still include UTXOs which
            only contain used BRC20 inscriptions
          required: false
          schema:
            type: boolean
            nullable: true
        - name: count
          in: query
          description: The max number of results per page
          required: false
          schema:
            allOf:
              - type: integer
                default: 100
                minimum: 0
            nullable: true
        - name: order
          in: query
          description: >-
            The order in which the results are sorted (by height at which UTxO
            was produced)
          required: false
          schema:
            allOf:
              - type: string
                default: asc
                enum:
                  - asc
                  - desc
            nullable: true
        - name: from
          in: query
          description: Return only UTxOs created on or after a specific height
          required: false
          schema:
            type: integer
            format: int64
            nullable: true
            minimum: 0
        - name: to
          in: query
          description: Return only UTxOs created on or before a specific height
          required: false
          schema:
            type: integer
            format: int64
            nullable: true
            minimum: 0
        - name: cursor
          in: query
          description: >-
            Pagination cursor string, use the cursor included in a page of
            results to fetch the next page
          required: false
          schema:
            type: string
            nullable: true
      responses:
        '200':
          description: Requested data
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedUtxo'
              example:
                data:
                  - address: >-
                      bc1phyrmjs2jm5c98tldke2ykp0h66lsx3wy0ey8ug2fjj5mxsn8ftqsa24un8
                    confirmations: 23
                    height: 2815497
                    inscriptions: []
                    runes: []
                    satoshis: '546'
                    script_pubkey: 00140df0d276eacd58b09a74d5e0288756e8505787f5
                    txid: >-
                      cb9532641412a6fa6f329e8728a8f7554dcaa6cdaec1355bd2bd2903cd61c6eb
                    vout: 1
                  - address: >-
                      bc1phyrmjs2jm5c98tldke2ykp0h66lsx3wy0ey8ug2fjj5mxsn8ftqsa24un8
                    confirmations: 20
                    height: 2815500
                    inscriptions:
                      - inscription_id: >-
                          47bb5438d366863b25b4b1782af0d0cf0a89a922adce5da81253790d3e651501i0
                        offset: 0
                    runes:
                      - amount: '1.00'
                        rune_id: '840000:1'
                    satoshis: '546'
                    script_pubkey: 00140df0d276eacd58b09a74d5e0288756e8505787f5
                    txid: >-
                      6312095baa2a42dec6aa41888c01fd74ecce2ab139c17a0a6d01d42a89b67953
                    vout: 1
                last_updated:
                  block_hash: >-
                    0000000088bee3b517745636443c8f11aff45209449300a5d8461c336e467925
                  block_height: 2815520
                next_cursor: AAAAAAAq9gxgU3m2iSrUAW0KesE5sSrO7HT9AYyIQarG3kIqqlsJEmNgAAAAAQ
        '400':
          description: Malformed query parameters
        '404':
          description: Requested entity not found on-chain
        '500':
          description: Internal server error
components:
  schemas:
    PaginatedUtxo:
      type: object
      required:
        - data
        - last_updated
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/Utxo'
        last_updated:
          $ref: '#/components/schemas/ChainTip'
        next_cursor:
          type: string
          nullable: true
    Utxo:
      type: object
      required:
        - txid
        - vout
        - script_pubkey
        - satoshis
        - confirmations
        - height
        - runes
        - inscriptions
      properties:
        address:
          type: string
          nullable: true
        confirmations:
          type: integer
          format: int64
          minimum: 0
        height:
          type: integer
          format: int64
          minimum: 0
        inscriptions:
          type: array
          items:
            $ref: '#/components/schemas/InscriptionAndOffset'
        runes:
          type: array
          items:
            $ref: '#/components/schemas/RuneAndAmount'
        satoshis:
          type: string
        script_pubkey:
          type: string
        txid:
          type: string
        vout:
          type: integer
          format: int32
          minimum: 0
    ChainTip:
      type: object
      required:
        - block_hash
        - block_height
      properties:
        block_hash:
          type: string
          description: The hash of the block
          example: 0000000000000000000a7f3b7b6b6e1d9a18db65a3b4a3f4f3bcb2e1f1b2d3e7
        block_height:
          type: integer
          format: int64
          description: The height of the block in the blockchain
          example: 707000
          minimum: 0
    InscriptionAndOffset:
      type: object
      required:
        - offset
        - inscription_id
      properties:
        inscription_id:
          type: string
        offset:
          type: integer
          format: int64
          minimum: 0
    RuneAndAmount:
      type: object
      required:
        - rune_id
        - amount
      properties:
        amount:
          type: string
        rune_id:
          type: string
  securitySchemes:
    api-key:
      type: apiKey
      in: header
      name: api-key
      description: Project API Key

````